Attribute VB_Name = "mdActions"
'
'Copyright (C) 2003-2006 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdActions.bas                                        *
'*Author:  Valeria Olivati - c/o Funambol - Pavia - Italy       *
'*                                                              *
'*This module contains all the functions for controlling the    *
'*the actions for the Items Properties and Values.              *
'*The actions are: Add new item, Update existing item, list item*
'*properties values and Delete item.                            *
'****************************************************************

Option Explicit
Public referredMaxDate As Date
Public limitMaxDate As Date
Public startDateToSubstituteWithPatterStartDate As Date




Public Sub populateDefaultDate()
    referredMaxDate = Format(CDate("01/01/4501"), "dd/mm/yyyy")
    limitMaxDate = Format(CDate("01/01/4000"), "dd/mm/yyyy")

End Sub

Public Function addItem(ByRef itemType As Integer, ByRef newItemProperties() As Variant) As String
    'This Function is used for adding in the folder referFolder a new Item of itemType type,
    'with the Properties listed in newItemProperties.
    'It returns the EntryID of the new item added

Dim referFolder As Outlook.MAPIFolder
Dim itemAppointment As Outlook.AppointmentItem
Dim itemContact As Outlook.ContactItem
Dim itemMail As Outlook.MailItem
Dim itemTask As Outlook.TaskItem
Dim itemNote As Outlook.NoteItem
Dim i As Integer

populateDefaultDate

'used for task
Dim Complete As Boolean
Complete = False

Dim ValueOfNoEndDate As Boolean
ValueOfNoEndDate = False
Dim IsRecurring As Boolean
IsRecurring = False
Dim objItemRecurrence As Outlook.RecurrencePattern

On Error GoTo addItem_Err

i = 0

'based on the Item type itemType
Select Case itemType
Case mdVariables.FOLDER_TYPE_CAL
    'loop through the folders list searching for the selected one
    Do While Not mdVariables.calendarFolders(i).Selected
        i = i + 1
    Loop
    'get a reference to the selected folder into MAPI NameSpace
    Set referFolder = mdVariables.nameSpace.GetFolderFromID(mdVariables.calendarFolders(i).EntryID)
    'add a new item into the selected folder
    Set itemAppointment = referFolder.Items.Add
   
    'loop through newItemProperties array reading the Item properties and values to assign to the new item
    'After modification for boolean the check with True or "True" should not be used. Only to be compliant with old version (pre 2.0.22)
    For i = 1 To UBound(newItemProperties)
        If (CStr(newItemProperties(i, 0)) = "IsRecurring") Then
            If ((CStr(newItemProperties(i, 0)) = "IsRecurring" And CBool(newItemProperties(i, 1))) Or _
                (CStr(newItemProperties(i, 0)) = "IsRecurring" And newItemProperties(i, 1) = "True") Or _
                (CStr(newItemProperties(i, 0)) = "IsRecurring" And newItemProperties(i, 1) = True)) Then
                    IsRecurring = True
            End If
       End If
        
        'assign the value newItemProperties(I, 1) of the property CStr(newItemProperties(I, 0)) for the Item itemAppointment
        letItemPropertyValue itemAppointment, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
    
    Next i
    
    If IsRecurring = False Then
        itemAppointment.ClearRecurrencePattern
    'Gestione recurrence pattern
    ElseIf itemType = mdVariables.FOLDER_TYPE_CAL Then
        Set objItemRecurrence = itemAppointment.GetRecurrencePattern
        
        For i = 1 To UBound(newItemProperties)
            If mdMMVariables.isPropertyInRecurrenceObject(CStr(newItemProperties(i, 0))) = True Then
                If newItemProperties(i, 0) = "RecurrenceType" Or (newItemProperties(i, 1) <> "0" _
                    And newItemProperties(i, 1) <> 0 And newItemProperties(i, 1) > 0) Then
                    
                    If CStr(newItemProperties(i, 0)) = "NoEndDate" Then
                        If newItemProperties(i, 1) = True Or newItemProperties(i, 1) = "True" Or CBool(newItemProperties(i, 1)) = True Then
                            ValueOfNoEndDate = True
                        End If
                    End If
                    If ((newItemProperties(i, 0) = "PatternEndDate" And ValueOfNoEndDate = True) Or _
                         (newItemProperties(i, 0) = "Occurrences" And ValueOfNoEndDate = True)) Then
                        'nothing
                    Else
                        letItemPropertyValue objItemRecurrence, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
                    End If
                End If
            Else
            End If
        Next i
    End If
    
    
    'MM
    itemAppointment.Save
    'return the EntryID of the new Item
    addItem = itemAppointment.EntryID
    logToDebug "itemAppointment EntryID: " & itemAppointment.EntryID
Case mdVariables.FOLDER_TYPE_CON
    'loop through the folders list searching for the selected one
    Do While Not mdVariables.contactsFolders(i).Selected
        i = i + 1
    Loop
    'get a reference to the selected folder into MAPI NameSpace
    Set referFolder = mdVariables.nameSpace.GetFolderFromID(mdVariables.contactsFolders(i).EntryID)
    'add a new item into the selected folder
    Set itemContact = referFolder.Items.Add
    'loop through newItemProperties array reading the Item properties and values to assign to the new item
    For i = 1 To UBound(newItemProperties)
        'assign the value newItemProperties(I, 1) of the property CStr(newItemProperties(I, 0)) for the Item itemContact
        letItemPropertyValue itemContact, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
    Next i
    
    itemContact.Save
    'return the EntryID of the new Item
    addItem = itemContact.EntryID
    logToDebug "itemContact EntryID: " & itemContact.EntryID
Case mdVariables.FOLDER_TYPE_MAIL
    'loop through the folders list searching for the selected one
    Do While Not mdVariables.mailFolders(i).Selected
        i = i + 1
    Loop
    'get a reference to the selected folder into MAPI NameSpace
    Set referFolder = mdVariables.nameSpace.GetFolderFromID(mdVariables.mailFolders(i).EntryID)
    'add a new item into the selected folder
    Set itemMail = referFolder.Items.Add
    'loop through newItemProperties array reading the Item properties and values to assign to the new item
    For i = 1 To UBound(newItemProperties)
        'assign the value newItemProperties(I, 1) of the property CStr(newItemProperties(I, 0)) for the Item itemMail
        letItemPropertyValue itemMail, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
    Next i
    itemMail.Save
    'return the EntryID of the new Item
    addItem = itemMail.EntryID
    logToDebug "itemMail EntryID: " & itemMail.EntryID
Case mdVariables.FOLDER_TYPE_TASK

    'loop through the folders list searching for the selected one
    Do While Not mdVariables.tasksFolders(i).Selected
        i = i + 1
    Loop
    'get a reference to the selected folder into MAPI NameSpace
    Set referFolder = mdVariables.nameSpace.GetFolderFromID(mdVariables.tasksFolders(i).EntryID)
    'add a new item into the selected folder
    Set itemTask = referFolder.Items.Add
   
    'loop through newItemProperties array reading the Item properties and values to assign to the new item
    For i = 1 To UBound(newItemProperties)
        If (CStr(newItemProperties(i, 0)) = "IsRecurring") Then
            If ((CStr(newItemProperties(i, 0)) = "IsRecurring" And CBool(newItemProperties(i, 1))) Or _
                (CStr(newItemProperties(i, 0)) = "IsRecurring" And newItemProperties(i, 1) = "True") Or _
                (CStr(newItemProperties(i, 0)) = "IsRecurring" And newItemProperties(i, 1) = True)) Then
                    IsRecurring = True
            End If
       End If
        
        'assign the value newItemProperties(I, 1) of the property CStr(newItemProperties(I, 0)) for the Item itemTask
         If (CStr(newItemProperties(i, 0)) = "Complete") Then
            If (CBool(newItemProperties(i, 1)) Or _
                newItemProperties(i, 1) = "True" Or _
                newItemProperties(i, 1) = True) Then
                    Complete = True
            Else
                    Complete = False
            End If
        End If
            
        If (CStr(newItemProperties(i, 0)) <> "PercentComplete" And CStr(newItemProperties(i, 0)) <> "Status") Then
            
            letItemPropertyValue itemTask, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
        Else
            If Complete = False Then
                letItemPropertyValue itemTask, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
            End If
            
        End If
    
    Next i
    
    If Complete = True Then
        itemTask.Status = olTaskComplete
        itemTask.PercentComplete = 100
    End If
        
    If IsRecurring = False Then
        itemTask.ClearRecurrencePattern
    'Gestione recurrence pattern
    ElseIf itemType = mdVariables.FOLDER_TYPE_TASK Then
        Set objItemRecurrence = itemTask.GetRecurrencePattern
        
    
        For i = 1 To UBound(newItemProperties)
            If mdMMVariables.isPropertyInRecurrenceObject(CStr(newItemProperties(i, 0))) = True Then
               If newItemProperties(i, 0) = "RecurrenceType" Or (newItemProperties(i, 1) <> "0" _
                    And newItemProperties(i, 1) <> 0 And newItemProperties(i, 1) > 0) Then
                    
                    If CStr(newItemProperties(i, 0)) = "NoEndDate" Then
                        If newItemProperties(i, 1) = True Or newItemProperties(i, 1) = "True" Or CBool(newItemProperties(i, 1)) = True Then
                            ValueOfNoEndDate = True
                        End If
                    End If
                    If ((newItemProperties(i, 0) = "PatternEndDate" And ValueOfNoEndDate = True) Or _
                        (newItemProperties(i, 0) = "Occurrences" And ValueOfNoEndDate = True)) Then
                        'nothing
                    Else
                        letItemPropertyValue objItemRecurrence, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
                    End If
                End If
            Else
            End If
        Next i
    End If
        
    'MM
    itemTask.Save
    'return the EntryID of the new Item
    addItem = itemTask.EntryID
    logToDebug "itemTask EntryID: " & itemTask.EntryID
    
Case mdVariables.FOLDER_TYPE_NOTE
    'loop through the folders list searching for the selected one
    Do While Not mdVariables.notesFolders(i).Selected
        i = i + 1
    Loop
    'get a reference to the selected folder into MAPI NameSpace
    Set referFolder = mdVariables.nameSpace.GetFolderFromID(mdVariables.notesFolders(i).EntryID)
    'add a new item into the selected folder
    Set itemNote = referFolder.Items.Add
    'loop through newItemProperties array reading the Item properties and values to assign to the new item
    For i = 1 To UBound(newItemProperties)
        'assign the value newItemProperties(I, 1) of the property CStr(newItemProperties(I, 0)) for the Item itemNote
        
            letItemPropertyValue itemNote, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
        
    Next i
    itemNote.Save
    'return the EntryID of the new Item
    addItem = itemNote.EntryID
    logToDebug "itemNote EntryID: " & itemNote.EntryID

End Select

addItem_Exit:
    Exit Function

addItem_Err:

    Dim actionToDo As Integer
        
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo addItem_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    
    Case 6
        addItem = "-1"
        GoTo addItem_Exit
    
    End Select

End Function

Public Function updateItem(ByRef itemEntryID As String, ByRef newItemProperties() As Variant)
    'This Sub is used for updating the properties listed in newItemProperties
    'for the Item identified by its EntryID

Dim objItem As Object
Dim i As Integer

On Error GoTo updateItem_Err

populateDefaultDate
'get a reference to the selected folder into MAPI NameSpace
Set objItem = nameSpace.GetItemFromID(itemEntryID)
logToDebug "objItem.Subject=" & objItem.Subject

Dim fileas As String

'loop through newItemProperties array reading the Item properties and values to assign to the new item
For i = 1 To UBound(newItemProperties)
    If CStr(newItemProperties(i, 0)) = "FileAs" Then
        fileas = newItemProperties(i, 1)
    End If
    'assign the value newItemProperties(I, 1) of the property CStr(newItemProperties(I, 0)) for the Item myTask
    letItemPropertyValue objItem, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
Next i

' modification to ensure that correct fileAs field is inserted:
' outlook modifies this field if thinks it's not valid
objItem.fileas = fileas
objItem.Save

updateItem = "0"

updateItem_Exit:
    Exit Function

updateItem_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo updateItem_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    Case 6
        updateItem = "-1"
        GoTo updateItem_Exit
    End Select

End Function
Public Function updateItemCalendar(ByRef itemEntryID As String, ByVal newItemProperties As Variant, ByRef itemType As Integer)
    'This Sub is used for updating the properties listed in newItemProperties
    'for the Item identified by its EntryID

Dim objItemAppointment As Outlook.AppointmentItem
Dim objItemTask As Outlook.TaskItem

Dim i As Integer
Dim objItemRecurrence As Outlook.RecurrencePattern
Dim ValueOfNoEndDate As Boolean
ValueOfNoEndDate = False
Dim IsRecurring As Boolean
IsRecurring = False

Dim Complete As Boolean
Complete = False

' set default values to mantain old values
Dim percentCompleteTask As Long
percentCompleteTask = 0
Dim statusTask As Integer
statusTask = 1 'inProgress

On Error GoTo updateItem_Err
populateDefaultDate
'get a reference to the selected folder into MAPI NameSpace
If itemType = mdVariables.FOLDER_TYPE_CAL Then
    
    Set objItemAppointment = mdVariables.nameSpace.GetItemFromID(itemEntryID)
    logToDebug "objItemAppointment.Subject=" & objItemAppointment.Subject
    objItemAppointment.ClearRecurrencePattern

ElseIf itemType = mdVariables.FOLDER_TYPE_TASK Then
    
    Set objItemTask = mdVariables.nameSpace.GetItemFromID(itemEntryID)
    logToDebug "objItemTask.Subject=" & objItemTask.Subject
    percentCompleteTask = objItemTask.PercentComplete
    statusTask = objItemTask.Status
    
    objItemTask.ClearRecurrencePattern

End If

'loop through newItemProperties array reading the Item properties and values to assign to the new item
For i = 1 To UBound(newItemProperties)
        'assign the value newItemProperties(I, 1) of the property CStr(newItemProperties(I, 0)) for the Item myTask
        If itemType = mdVariables.FOLDER_TYPE_CAL Then
            letItemPropertyValue objItemAppointment, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
        
        ElseIf itemType = mdVariables.FOLDER_TYPE_TASK Then
        
            If (CStr(newItemProperties(i, 0)) = "Complete") Then
                If (CBool(newItemProperties(i, 1)) Or _
                    newItemProperties(i, 1) = "True" Or _
                    newItemProperties(i, 1) = True) Then
                        Complete = True
                Else
                        Complete = False
                End If
            End If
            
            ' check particular value percentComplete and status of the task
            If CStr(newItemProperties(i, 0)) = "Status" And (newItemProperties(i, 1) = Empty _
                    Or newItemProperties(i, 1) = Null Or newItemProperties(i, 1) = "") Then
                objItemTask.Status = statusTask
                
            ElseIf CStr(newItemProperties(i, 0)) = "PercentComplete" And (newItemProperties(i, 1) = Empty _
                    Or newItemProperties(i, 1) = Null Or newItemProperties(i, 1) = "") Then
                    
                objItemTask.PercentComplete = percentCompleteTask
            Else
               If (CStr(newItemProperties(i, 0)) <> "PercentComplete" And CStr(newItemProperties(i, 0)) <> "Status") Then
                 letItemPropertyValue objItemTask, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
               Else
                 If Complete = False Then
                    letItemPropertyValue objItemTask, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
                 End If
               End If
              
            End If
        
        End If
               
        If (CStr(newItemProperties(i, 0)) = "IsRecurring") Then
            If ((CStr(newItemProperties(i, 0)) = "IsRecurring" And CBool(newItemProperties(i, 1))) Or _
                (CStr(newItemProperties(i, 0)) = "IsRecurring" And newItemProperties(i, 1) = "True") Or _
                (CStr(newItemProperties(i, 0)) = "IsRecurring" And newItemProperties(i, 1) = True)) Then
                    IsRecurring = True
            End If
       End If
        
Next i

If itemType = mdVariables.FOLDER_TYPE_TASK Then
    If Complete = True Then
        objItemTask.Status = olTaskComplete
        objItemTask.PercentComplete = 100
    End If
End If
    
If IsRecurring = False Then
    If itemType = mdVariables.FOLDER_TYPE_CAL Then
        objItemAppointment.ClearRecurrencePattern
    ElseIf itemType = mdVariables.FOLDER_TYPE_TASK Then
        objItemTask.ClearRecurrencePattern
    End If

'Gestione recurrence pattern
ElseIf itemType = mdVariables.FOLDER_TYPE_CAL Or itemType = mdVariables.FOLDER_TYPE_TASK Then
    
    If itemType = mdVariables.FOLDER_TYPE_CAL Then
        Set objItemRecurrence = objItemAppointment.GetRecurrencePattern
    ElseIf itemType = mdVariables.FOLDER_TYPE_TASK Then
        Set objItemRecurrence = objItemTask.GetRecurrencePattern
    End If
    
    
    Dim recType As Integer
    For i = 1 To UBound(newItemProperties)
        If mdMMVariables.isPropertyInRecurrenceObject(CStr(newItemProperties(i, 0))) = True Then
            If newItemProperties(i, 0) = "RecurrenceType" Or (newItemProperties(i, 1) <> "0" _
                    And newItemProperties(i, 1) <> 0 And newItemProperties(i, 1) > 0) Then
                    
                    If CStr(newItemProperties(i, 0)) = "NoEndDate" Then
                        If newItemProperties(i, 1) = True Or newItemProperties(i, 1) = "True" Or CBool(newItemProperties(i, 1)) = True Then
                            ValueOfNoEndDate = True
                        End If
                    End If
                    If ((newItemProperties(i, 0) = "PatternEndDate" And ValueOfNoEndDate = True) Or _
                        (newItemProperties(i, 0) = "Occurrences" And ValueOfNoEndDate = True)) Then
                        'nothing
                    Else
                        letItemPropertyValue objItemRecurrence, CStr(newItemProperties(i, 0)), newItemProperties(i, 1)
                        
                    
                    End If
            End If
        Else
            'nothing
        End If
    Next i
End If

If itemType = mdVariables.FOLDER_TYPE_CAL Then
    objItemAppointment.Save
ElseIf itemType = mdVariables.FOLDER_TYPE_TASK Then
    objItemTask.Save
End If
    
updateItemCalendar = "0"

updateItem_Exit:
    Exit Function

updateItem_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo updateItem_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    Case 6
        updateItemCalendar = "-1"
        GoTo updateItem_Exit
    End Select

End Function

Public Sub removeItem(ByRef itemEntryID As String)
    'This Sub is used for removing the Item identified by its EntryID

Dim objItem As Object

On Error GoTo removeItem_Err
populateDefaultDate
'get a reference to the selected item identified into MAPI NameSpace by its EntryID
Set objItem = nameSpace.GetItemFromID(itemEntryID)
logToDebug "objItem.Subject=" & objItem.Subject
'delete the referenced item
objItem.Delete
frmActions.lblRemoved.Visible = True

removeItem_Exit:
    Exit Sub

removeItem_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo removeItem_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub

Public Function getItemProperties(ByRef itemEntryID As String) As Variant
    'This Function is used for reading the values of the selected properties
    'for the Item identified by its EntryID

Dim objItem As Object
Dim readingArray() As Variant
Dim i As Integer
isAllDayEvent = False

On Error GoTo getItemProperties_Err

'get a reference to the selected item identified into MAPI NameSpace by its EntryID
Set objItem = mdVariables.nameSpace.GetItemFromID(itemEntryID)
logToDebug "objItem.Subject=" & objItem.Subject

'based on the Item Class
Select Case objItem.Class
Case olAppointment
    'redim the array for listing the Item Property and its value and ID
    ReDim readingArray(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    'in the first position write the Class of the Item
    readingArray(0, 0) = "Class"
    readingArray(0, 1) = olAppointment
    'loop through the selected Item properties reading the values
    For i = 1 To UBound(readingArray)
        readingArray(i, 0) = mdVariables.calendarProperties(i).Property
        readingArray(i, 1) = getItemPropertyValue(objItem, mdVariables.calendarProperties(i).Property)
    Next i
Case olContact
    'redim the array for listing the Item Property and its value and ID
    ReDim readingArray(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    'in the first position write the Class of the Item
    readingArray(0, 0) = "Class"
    readingArray(0, 1) = olContact
    'loop through the selected Item properties reading the values
    For i = 1 To UBound(readingArray)
        readingArray(i, 0) = mdVariables.contactsProperties(i).Property
        readingArray(i, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.contactsProperties(i).Property)
    Next i
Case olMail
    'redim the array for listing the Item Property and its value and ID
    ReDim readingArray(0 To UBound(mdVariables.mailProperties), 0 To 1)
    'in the first position write the Class of the Item
    readingArray(0, 0) = "Class"
    readingArray(0, 1) = olMail
    'loop through the selected Item properties reading the values
    For i = 1 To UBound(readingArray)
        readingArray(i, 0) = mdVariables.mailProperties(i).Property
        readingArray(i, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.mailProperties(i).Property)
    Next i
Case olTask
    'redim the array for listing the Item Property and its value and ID
    ReDim readingArray(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    'in the first position write the Class of the Item
    readingArray(0, 0) = "Class"
    readingArray(0, 1) = olTask
    'loop through the selected Item properties reading the values
    For i = 1 To UBound(readingArray)
        readingArray(i, 0) = mdVariables.tasksProperties(i).Property
        readingArray(i, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.tasksProperties(i).Property)
    Next i
Case olNote
    'redim the array for listing the Item Property and its value and ID
    ReDim readingArray(0 To UBound(mdVariables.notesProperties), 0 To 1)
    'in the first position write the Class of the Item
    readingArray(0, 0) = "Class"
    readingArray(0, 1) = olNote
    'loop through the selected Item properties reading the values
    For i = 1 To UBound(readingArray)
        readingArray(i, 0) = mdVariables.notesProperties(i).Property
        readingArray(i, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.notesProperties(i).Property)
    Next i
Case Else
    ReDim readingArray(0)
End Select

'return the array listing the Item properties and values
getItemProperties = readingArray

getItemProperties_Exit:
    Exit Function

getItemProperties_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getItemProperties_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Function

Public Function getItemPropertyValue(ByRef objItem As Object, ByRef nameOfProperty As String) As Variant
'
'
'FROM Client to server
'
'
'return the value of nameOfProperty for objItem
'translate the time from local to utc to be send to server

On Error GoTo getItemPropertyValue_Err
populateDefaultDate
Select Case nameOfProperty
Case "Account"
  getItemPropertyValue = objItem.Account
Case "ActualWork"
  getItemPropertyValue = objItem.ActualWork
Case "AllDayEvent"
  If (CBool(objItem.AllDayEvent)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
Case "AlternateRecipientAllowed"
  getItemPropertyValue = objItem.AlternateRecipientAllowed
Case "Anniversary"
  'getItemPropertyValue = Format(objItem.Anniversary, "dd/mm/yyyy hh\:mm\:ss") 'objItem.Anniversary
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.Anniversary), "yyyyMMddTHHmmss") 'objItem.Anniversary
  'getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.Anniversary)
  If limitMaxDate > objItem.Anniversary Then
    getItemPropertyValue = Format(objItem.Anniversary, "yyyy-mm-dd")
  Else
    getItemPropertyValue = ""
  End If
  
Case "AssistantName"
  getItemPropertyValue = objItem.AssistantName
Case "AssistantTelephoneNumber"
  getItemPropertyValue = objItem.AssistantTelephoneNumber
Case "BCC"
  getItemPropertyValue = objItem.BCC
Case "BillingInformation"
  getItemPropertyValue = objItem.BillingInformation
Case "Birthday"
  'getItemPropertyValue = Format(objItem.Birthday, "dd/mm/yyyy hh\:mm\:ss") 'objItem.Birthday
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.Birthday), "yyyyMMddTHHmmss") 'objItem.Birthday
  'getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.Birthday)
   If limitMaxDate > objItem.Birthday Then
    getItemPropertyValue = Format(objItem.Birthday, "yyyy-mm-dd")
  Else
    getItemPropertyValue = ""
  End If
    
Case "Body"
    Dim b As String
    Dim c As String
    
    c = ""
    b = objItem.Body
    'Dim bb() As Byte
    'bb = StringToByteArray(objItem.Body)
    
    c = Right(b, 2)
    
    If c = Chr$(13) & Chr$(10) Then
        b = Left(b, Len(b) - 2)
    End If
    getItemPropertyValue = b
Case "BodyFormat"
  getItemPropertyValue = objItem.BodyFormat
Case "Business2TelephoneNumber"
  getItemPropertyValue = objItem.Business2TelephoneNumber
Case "BusinessAddress"
  getItemPropertyValue = objItem.BusinessAddress
'MM
Case "BusinessAddressStreet"
 getItemPropertyValue = objItem.BusinessAddressStreet
Case "BusinessAddressCity"
 getItemPropertyValue = objItem.BusinessAddressCity
Case "BusinessAddressState"
 getItemPropertyValue = objItem.BusinessAddressState
Case "BusinessAddressPostalCode"
 getItemPropertyValue = objItem.BusinessAddressPostalCode
Case "BusinessAddressCountry"
 getItemPropertyValue = objItem.BusinessAddressCountry
Case "BusinessAddressPostOfficeBox"
 getItemPropertyValue = objItem.BusinessAddressPostOfficeBox
  
Case "BusinessFaxNumber"
  getItemPropertyValue = objItem.BusinessFaxNumber
'Removed BusinessHomePage. User WebPage only
'Case "BusinessHomePage"
'  getItemPropertyValue = objItem.BusinessHomePage
'Reintroduced BusinessWebPage. instead of BusinessHomePage
Case "BusinessWebPage"
  getItemPropertyValue = objItem.BusinessHomePage

Case "BusinessTelephoneNumber"
  getItemPropertyValue = objItem.BusinessTelephoneNumber
Case "BusyStatus"
  getItemPropertyValue = objItem.BusyStatus
Case "CallbackTelephoneNumber"
  getItemPropertyValue = objItem.CallbackTelephoneNumber
Case "CardData"
  getItemPropertyValue = objItem.CardData
Case "CarTelephoneNumber"
  getItemPropertyValue = objItem.CarTelephoneNumber
Case "Categories"
  getItemPropertyValue = objItem.Categories
Case "CC"
  getItemPropertyValue = objItem.CC
Case "Children"
  getItemPropertyValue = objItem.Children
Case "Companies"
  getItemPropertyValue = objItem.Companies
Case "CompanyMainTelephoneNumber"
  getItemPropertyValue = objItem.CompanyMainTelephoneNumber
Case "CompanyName"
  getItemPropertyValue = objItem.CompanyName
Case "Complete"
  If (CBool(objItem.Complete)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
Case "ComputerNetworkName"
  getItemPropertyValue = objItem.ComputerNetworkName
Case "ContactNames"
  getItemPropertyValue = objItem.ContactNames
Case "CustomerID"
  getItemPropertyValue = objItem.CustomerID
Case "Date"
  'getItemPropertyValue = Format(objItem.End, "dd/mm/yyyy hh\:mm\:ss") 'objItem.End
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.End), "yyyyMMddTHHmmss")
  getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.LastModificationTime)
Case "DateCompleted"
  'getItemPropertyValue = Format(objItem.DateCompleted, "dd/mm/yyyy hh\:mm\:ss") 'objItem.DateCompleted
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.DateCompleted), "yyyyMMddTHHmmss")
  
  If limitMaxDate > objItem.DateCompleted Then
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.DateCompleted)
  Else
    getItemPropertyValue = ""
  End If
Case "DeferredDeliveryTime"
  getItemPropertyValue = objItem.DeferredDeliveryTime
Case "DeleteAfterSubmit"
  getItemPropertyValue = objItem.DeleteAfterSubmit
Case "Department"
  getItemPropertyValue = objItem.Department
Case "DueDate"
  'getItemPropertyValue = Format(objItem.DueDate, "dd/mm/yyyy hh\:mm\:ss") 'objItem.DueDate
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.DueDate), "yyyyMMddTHHmmss")
  'getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.DueDate)
  If limitMaxDate > objItem.DueDate Then
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.DueDate)
  Else
    getItemPropertyValue = ""
  End If
Case "Duration"
  getItemPropertyValue = objItem.Duration
Case "Email1Address"
  getItemPropertyValue = objItem.Email1Address
Case "Email1AddressType"
  getItemPropertyValue = objItem.Email1AddressType
Case "Email2Address"
  getItemPropertyValue = objItem.Email2Address
Case "Email2AddressType"
  getItemPropertyValue = objItem.Email2AddressType
Case "Email3Address"
  getItemPropertyValue = objItem.Email3Address
Case "Email3AddressType"
  getItemPropertyValue = objItem.Email3AddressType
Case "End"
  'getItemPropertyValue = Format(objItem.End, "dd/mm/yyyy hh\:mm\:ss") 'objItem.End
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.End), "yyyyMMddTHHmmss")
  If mdMMVariables.isAllDayEvent Then
    Dim td As Date
    td = objItem.End
    td = DateAdd("d", -1, td)
    getItemPropertyValue = Format(td, "yyyy-mm-dd")
  Else
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.End)
  End If
Case "ExpiryTime"
  getItemPropertyValue = objItem.ExpiryTime
Case "FileAs"
  getItemPropertyValue = objItem.fileas
Case "FlagDueBy"
  getItemPropertyValue = objItem.FlagDueBy
Case "FlagRequest"
  getItemPropertyValue = objItem.FlagRequest
Case "FlagStatus"
  getItemPropertyValue = objItem.FlagStatus
Case "FTPSite"
  getItemPropertyValue = objItem.FTPSite
Case "FullName"
  getItemPropertyValue = objItem.FullName
Case "GovernmentIDNumber"
  getItemPropertyValue = objItem.GovernmentIDNumber
Case "Hobby"
  getItemPropertyValue = objItem.Hobby
Case "Home2TelephoneNumber"
  getItemPropertyValue = objItem.Home2TelephoneNumber
Case "HomeAddress"
  getItemPropertyValue = objItem.HomeAddress

'MM
Case "HomeAddressStreet"
 getItemPropertyValue = objItem.HomeAddressStreet
Case "HomeAddressCity"
 getItemPropertyValue = objItem.HomeAddressCity
Case "HomeAddressState"
 getItemPropertyValue = objItem.HomeAddressState
Case "HomeAddressPostalCode"
 getItemPropertyValue = objItem.HomeAddressPostalCode
Case "HomeAddressCountry"
 getItemPropertyValue = objItem.HomeAddressCountry
Case "HomeAddressPostOfficeBox"
 getItemPropertyValue = objItem.HomeAddressPostOfficeBox

Case "HomeFaxNumber"
  getItemPropertyValue = objItem.HomeFaxNumber
Case "HomeTelephoneNumber"
  getItemPropertyValue = objItem.HomeTelephoneNumber
Case "HTMLBody"
  getItemPropertyValue = objItem.HTMLBody
Case "IMAddress"
  getItemPropertyValue = objItem.IMAddress
Case "Importance"
  getItemPropertyValue = objItem.Importance
Case "Initials"
  getItemPropertyValue = objItem.Initials
Case "InternetFreeBusyAddress"
  getItemPropertyValue = objItem.InternetFreeBusyAddress
Case "ISDNNumber"
  getItemPropertyValue = objItem.ISDNNumber
Case "IsOnlineMeeting"
   If (CBool(objItem.IsOnlineMeeting)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
Case "IsRecurring"
  If (CBool(objItem.IsRecurring)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
  
Case "ItemProperties"
  getItemPropertyValue = objItem.itemProperties
Case "JobTitle"
  getItemPropertyValue = objItem.JobTitle
Case "Location"
  getItemPropertyValue = objItem.Location
Case "Language"
  getItemPropertyValue = objItem.Language
Case "MailingAddress"
  getItemPropertyValue = objItem.MailingAddress
Case "ManagerName"
  getItemPropertyValue = objItem.ManagerName
Case "MarkForDownload"
  getItemPropertyValue = objItem.MarkForDownload
Case "MeetingStatus"
  getItemPropertyValue = objItem.MeetingStatus
Case "Mileage"
  getItemPropertyValue = objItem.Mileage
Case "MiddleName"
  getItemPropertyValue = objItem.MiddleName
Case "MobileTelephoneNumber"
  getItemPropertyValue = objItem.MobileTelephoneNumber
Case "NetMeetingAlias"
  getItemPropertyValue = objItem.NetMeetingAlias
Case "NetMeetingAutoStart"
  getItemPropertyValue = objItem.NetMeetingAutoStart
Case "NetMeetingDocPathName"
  getItemPropertyValue = objItem.NetMeetingDocPathName
Case "NetMeetingOrganizerAlias"
  getItemPropertyValue = objItem.NetMeetingOrganizerAlias
Case "NetMeetingServer"
  getItemPropertyValue = objItem.NetMeetingServer
Case "NetMeetingType"
  getItemPropertyValue = objItem.NetMeetingType
Case "NetShowURL"
  getItemPropertyValue = objItem.NetShowURL
Case "NickName"
  getItemPropertyValue = objItem.NickName
Case "NoAging"
  If (CBool(objItem.NoAging)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
Case "OfficeLocation"
  getItemPropertyValue = objItem.OfficeLocation
Case "OptionalAttendees"
  getItemPropertyValue = objItem.OptionalAttendees
Case "OrganizationalIDNumber"
  getItemPropertyValue = objItem.OrganizationalIDNumber
Case "OriginatorDeliveryReportRequested"
  getItemPropertyValue = objItem.OriginatorDeliveryReportRequested
Case "OtherAddress"
  getItemPropertyValue = objItem.OtherAddress

'MM
Case "OtherAddressStreet"
 getItemPropertyValue = objItem.OtherAddressStreet
Case "OtherAddressCity"
 getItemPropertyValue = objItem.OtherAddressCity
Case "OtherAddressState"
 getItemPropertyValue = objItem.OtherAddressState
Case "OtherAddressPostalCode"
 getItemPropertyValue = objItem.OtherAddressPostalCode
Case "OtherAddressCountry"
 getItemPropertyValue = objItem.OtherAddressCountry
Case "OtherAddressPostOfficeBox"
 getItemPropertyValue = objItem.OtherAddressPostOfficeBox
  
Case "OtherFaxNumber"
  getItemPropertyValue = objItem.OtherFaxNumber
Case "OtherTelephoneNumber"
  getItemPropertyValue = objItem.OtherTelephoneNumber
Case "Owner"
  getItemPropertyValue = objItem.Owner
Case "PagerNumber"
  getItemPropertyValue = objItem.PagerNumber
Case "PercentComplete"
logToDebug objItem.PercentComplete
  getItemPropertyValue = objItem.PercentComplete
'Case "PersonalHomePage"
'  getItemPropertyValue = objItem.PersonalHomePage
'Modified From PersonalHomePage to PersonalWebPage
'Modified From PersonalWebPage to HomeWebPage
Case "HomeWebPage"
  getItemPropertyValue = objItem.PersonalHomePage
  
Case "PrimaryTelephoneNumber"
  getItemPropertyValue = objItem.PrimaryTelephoneNumber
Case "Profession"
  getItemPropertyValue = objItem.Profession
Case "RadioTelephoneNumber"
  getItemPropertyValue = objItem.RadioTelephoneNumber
Case "ReadReceiptRequested"
  getItemPropertyValue = objItem.ReadReceiptRequested
Case "ReplyTime"
  If limitMaxDate > objItem.ReplyTime Then
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.ReplyTime)
  Else
    getItemPropertyValue = ""
  End If

Case "Role"
  getItemPropertyValue = objItem.Role
Case "SchedulePlusPriority"
  getItemPropertyValue = objItem.SchedulePlusPriority
Case "SelectedMailingAddress"
  getItemPropertyValue = objItem.SelectedMailingAddress
Case "SentOnBehalfOfName"
  getItemPropertyValue = objItem.SentOnBehalfOfName
Case "Sensitivity"
  getItemPropertyValue = objItem.Sensitivity
Case "Spouse"
  getItemPropertyValue = objItem.Spouse
Case "Start"
  'getItemPropertyValue = Format(objItem.Start, "dd/mm/yyyy hh\:mm\:ss")
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.Start), "yyyyMMddTHHmmss")
  If mdMMVariables.isAllDayEvent Then
    getItemPropertyValue = Format(objItem.Start, "yyyy-mm-dd")
  Else
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.Start)
  End If
  
Case "StartDate"
  'getItemPropertyValue = Format(objItem.StartDate, "dd/mm/yyyy hh\:mm\:ss") 'objItem.StartDate
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.StartDate), "yyyyMMddTHHmmss")
  getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.StartDate)
Case "Status"
  getItemPropertyValue = objItem.Status
Case "Subject"
  getItemPropertyValue = objItem.Subject
Case "Suffix"
  getItemPropertyValue = objItem.Suffix
Case "TeamTask"
  If (CBool(objItem.TeamTask)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
Case "TelexNumber"
  getItemPropertyValue = objItem.TelexNumber
Case "Title"
  getItemPropertyValue = objItem.Title
Case "To"
  getItemPropertyValue = objItem.To
Case "TotalWork"
  getItemPropertyValue = objItem.TotalWork
Case "TTYTDDTelephoneNumber"
  getItemPropertyValue = objItem.TTYTDDTelephoneNumber
Case "UnRead"
  getItemPropertyValue = objItem.UnRead
Case "User1"
  getItemPropertyValue = objItem.User1
Case "User2"
  getItemPropertyValue = objItem.User2
Case "User3"
  getItemPropertyValue = objItem.User3
Case "User4"
  getItemPropertyValue = objItem.User4
Case "UserCertificate"
  getItemPropertyValue = objItem.UserCertificate
Case "UserProperties"
  getItemPropertyValue = objItem.UserProperties
Case "VotingOptions"
  getItemPropertyValue = objItem.VotingOptions
Case "VotingResponse"
  getItemPropertyValue = objItem.VotingResponse
Case "WebPage"
  getItemPropertyValue = objItem.WebPage
Case "YomiCompanyName"
  getItemPropertyValue = objItem.YomiCompanyName
Case "YomiFirstName"
  getItemPropertyValue = objItem.YomiFirstName
Case "YomiLastName"
  getItemPropertyValue = objItem.YomiLastName
Case "FirstName"
  getItemPropertyValue = objItem.FirstName
Case "LastName"
  getItemPropertyValue = objItem.LastName
Case "ReminderSet"
  If (CBool(objItem.ReminderSet)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
Case "ReminderMinutesBeforeStart"
  getItemPropertyValue = objItem.ReminderMinutesBeforeStart
Case "ReminderTime"
  If limitMaxDate > objItem.ReminderTime Then
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.ReminderTime)
  Else
    getItemPropertyValue = ""
  End If

'MM for Recurrence
Case "RecurrenceType"
  getItemPropertyValue = objItem.recurrenceType
Case "Interval"
  getItemPropertyValue = objItem.interval
Case "MonthOfYear"
  getItemPropertyValue = objItem.monthOfYear
Case "DayOfMonth"
  getItemPropertyValue = objItem.dayOfMonth
Case "DayOfWeekMask"
  getItemPropertyValue = objItem.dayOfWeekMask
Case "Instance"
  getItemPropertyValue = objItem.instance
Case "PatternStartDate"
  'getItemPropertyValue = Format(objItem.PatternStartDate, "dd/mm/yyyy hh\:mm\:ss") 'objItem.PatternStartDate
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.PatternStartDate), "yyyyMMddTHHmmss")
  
   If limitMaxDate > objItem.patternStartDate Then
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.patternStartDate)
  Else
    getItemPropertyValue = ""
  End If
  
Case "PatternEndDate"
  'getItemPropertyValue = Format(objItem.PatternEndDate, "dd/mm/yyyy hh\:mm\:ss") 'objItem.PatternEndDate
  'getItemPropertyValue = Format(mdMMTimeUtils.LocalToUTC(objItem.PatternEndDate), "yyyyMMddTHHmmss")
  If limitMaxDate > objItem.PatternEndDate Then
    getItemPropertyValue = mdMMTimeUtils.LocalToUTC(objItem.PatternEndDate)
  Else
    getItemPropertyValue = ""
  End If
Case "NoEndDate"
  If (CBool(objItem.noEndDate)) Then
    getItemPropertyValue = 1
  Else
    getItemPropertyValue = 0
  End If
Case "Occurrences"
  getItemPropertyValue = objItem.occurrences
  
'Add for notes
Case "Color"
  getItemPropertyValue = objItem.Color
Case "Height"
  getItemPropertyValue = objItem.Height
Case "Width"
  getItemPropertyValue = objItem.Width
Case "Top"
  getItemPropertyValue = objItem.Top
Case "Left"
  getItemPropertyValue = objItem.Left
  
 
End Select

getItemPropertyValue_Exit:
    Exit Function

getItemPropertyValue_Err:

    Dim actionToDo As Integer

    If Err.number = 380 Then 'Invalid property value
        logToDebug "You're trying to get a not valid value for the Item Property. The Item with the EntryID" _
        & Chr(13) & objItem.EntryID & Chr(13) & "was not properly read."
        Resume Next
    End If
    If Err.number = 438 Then 'Object doesn't support this property or method
        logToDebug "You're trying to get a not valid Item Property for the current Item type. The Item with the EntryID" _
        & Chr(13) & objItem.EntryID & Chr(13) & "will not be completely read."
        Exit Function
    End If

    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getItemPropertyValue_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Function

Public Sub letItemPropertyValue(ByRef objItem As Object, ByRef nameOfProperty As String, ByRef valueOfItem As Variant)
    'assign valueOfItem at nameOfProperty for objItem
    'translate the time from utc to local to be written into outlook
    'Transformation Data into canonical representation dd/mm/yyyy hh:mm:ss
    ' is performed by mdMMTimeUtils.dateToCanonical to try the date
    '
    'SERVER to CLIENT
    '
If IsEmpty(valueOfItem) Then
    Exit Sub
End If
        
        
        
On Error GoTo letItemPropertyValue_Err
populateDefaultDate
Select Case VarType(valueOfItem)
Case vbEmpty
    logToDebug "0 Uninitialized (default)"
Case vbNull
    logToDebug "1 Contains no valid data"
Case vbInteger
    logToDebug "2 Integer subtype"
Case vbLong
    logToDebug "3 Long subtype"
Case vbSingle
    logToDebug "4 Single subtype"
Case vbDouble
    logToDebug "5 Double subtype"
Case vbCurrency
    logToDebug "6 Currency subtype"
Case vbDate
    logToDebug "7 Date subtype"
Case vbString
    logToDebug "8 String subtype"
    '
    ' modification to convert &amp; into & --- &lt; into < ---- &gt; into >
    '
    valueOfItem = replaceMinorAndMajorAndAmpFromServer(valueOfItem)
Case vbObject
    logToDebug "9 Object"
Case vbError
    logToDebug "10 Error subtype"
Case vbBoolean
    logToDebug "11 Boolean subtype"
Case vbVariant
    logToDebug "12 Variant (used only for arrays of variants)"
Case vbDataObject
    logToDebug "13 Data access object"
Case vbDecimal
    logToDebug "14 Decimal subtype"
Case vbByte
    controlMsgBox "17 Byte subtype"
Case vbArray
    controlMsgBox "8192 Array"
End Select

Dim tmpDate As Date


Select Case nameOfProperty
Case "Account"
 objItem.Account = valueOfItem
Case "ActualWork"
 objItem.ActualWork = valueOfItem
Case "AllDayEvent"
 objItem.AllDayEvent = valueOfItem
Case "AlternateRecipientAllowed"
 objItem.AlternateRecipientAllowed = valueOfItem
Case "Anniversary"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    'tmpDate = Format(CDate(valueOfItem), "dd/mm/yyyy hh:mm:ss") 'valueOfItem
    'objItem.Anniversary = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.Anniversary = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.Anniversary = tmpDate
    Else
        objItem.Anniversary = referredMaxDate
    End If
 End If
Case "AssistantName"
 objItem.AssistantName = valueOfItem
Case "AssistantTelephoneNumber"
 objItem.AssistantTelephoneNumber = valueOfItem
Case "BCC"
 objItem.BCC = valueOfItem
Case "BillingInformation"
 objItem.BillingInformation = valueOfItem
Case "Birthday"
'fix dummy anniversary event
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    If tmpDate < limitMaxDate Then
    'objItem.Birthday = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
        'objItem.Birthday = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.Birthday = tmpDate
    Else
        objItem.Birthday = referredMaxDate
    End If
 End If
Case "Body"
 objItem.Body = valueOfItem
Case "BodyFormat"
 objItem.BodyFormat = valueOfItem
Case "Business2TelephoneNumber"
 objItem.Business2TelephoneNumber = valueOfItem
Case "BusinessAddress"
 objItem.BusinessAddress = valueOfItem
'MM
Case "BusinessAddressStreet"
 objItem.BusinessAddressStreet = valueOfItem
Case "BusinessAddressCity"
 objItem.BusinessAddressCity = valueOfItem
Case "BusinessAddressState"
 objItem.BusinessAddressState = valueOfItem
Case "BusinessAddressPostalCode"
 objItem.BusinessAddressPostalCode = valueOfItem
Case "BusinessAddressCountry"
 objItem.BusinessAddressCountry = valueOfItem
Case "BusinessAddressPostOfficeBox"
 objItem.BusinessAddressPostOfficeBox = valueOfItem

Case "BusinessFaxNumber"
 objItem.BusinessFaxNumber = valueOfItem

'removed: used only WebPage
'Case "BusinessHomePage"
' objItem.BusinessHomePage = valueOfItem
Case "BusinessTelephoneNumber"
 objItem.BusinessTelephoneNumber = valueOfItem
Case "BusyStatus"
 objItem.BusyStatus = valueOfItem
Case "CallbackTelephoneNumber"
 objItem.CallbackTelephoneNumber = valueOfItem
Case "CardData"
 objItem.CardData = valueOfItem
Case "CarTelephoneNumber"
 objItem.CarTelephoneNumber = valueOfItem
Case "Categories"
 objItem.Categories = valueOfItem
Case "CC"
 objItem.CC = valueOfItem
Case "Children"
 objItem.Children = valueOfItem
Case "Companies"
 objItem.Companies = valueOfItem
Case "CompanyMainTelephoneNumber"
 objItem.CompanyMainTelephoneNumber = valueOfItem
Case "CompanyName"
 objItem.CompanyName = valueOfItem
Case "Complete"
 objItem.Complete = valueOfItem
Case "ComputerNetworkName"
 objItem.ComputerNetworkName = valueOfItem
Case "ContactNames"
 objItem.ContactNames = valueOfItem
Case "CustomerID"
 objItem.CustomerID = valueOfItem
Case "DateCompleted"
If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.DateCompleted = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
        'objItem.DateCompleted = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.DateCompleted = tmpDate
    Else
         objItem.DateCompleted = referredMaxDate
    End If
       
End If
Case "DeferredDeliveryTime"
 objItem.DeferredDeliveryTime = valueOfItem
Case "DeleteAfterSubmit"
 objItem.DeleteAfterSubmit = valueOfItem
Case "Department"
 objItem.Department = valueOfItem
Case "DueDate"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    'objItem.DueDate = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.DueDate = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.DueDate = tmpDate
    Else
        objItem.DueDate = referredMaxDate
    End If
 End If
Case "Duration"
 objItem.Duration = valueOfItem
Case "Email1Address"
 objItem.Email1Address = valueOfItem
Case "Email1AddressType"
 objItem.Email1AddressType = valueOfItem
Case "Email2Address"
 objItem.Email2Address = valueOfItem
Case "Email2AddressType"
 objItem.Email2AddressType = valueOfItem
Case "Email3Address"
 objItem.Email3Address = valueOfItem
Case "Email3AddressType"
 objItem.Email3AddressType = valueOfItem
Case "End"
If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then

    tmpDate = Empty
    
    'If mdMMVariables.isAllDayEvent = False Then
        tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
        'objItem.End = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    'Else
    '    tmpDate = Format(CDate(Format(valueOfItem, "yyyy/mm/dd hh:mm:ss")), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    '    tmpDate = CDate(Day(valueOfItem) & " " & MonthName(Month(valueOfItem)) & _
    '   ", " & Year(valueOfItem) & " " & Hour(valueOfItem) & ":" & Minute(valueOfItem) & ":" & Second(valueOfItem))
    'End If
        If tmpDate < limitMaxDate Then
        objItem.End = tmpDate
    Else
        objItem.End = referredMaxDate
    End If
End If
Case "ExpiryTime"
 objItem.ExpiryTime = valueOfItem
Case "FileAs"
 objItem.fileas = valueOfItem
Case "FlagDueBy"
 objItem.FlagDueBy = valueOfItem
Case "FlagRequest"
 objItem.FlagRequest = valueOfItem
Case "FlagStatus"
 objItem.FlagStatus = valueOfItem
Case "FTPSite"
 objItem.FTPSite = valueOfItem
Case "FullName"
 objItem.FullName = valueOfItem
Case "GovernmentIDNumber"
 objItem.GovernmentIDNumber = valueOfItem
Case "Hobby"
 objItem.Hobby = valueOfItem
Case "Home2TelephoneNumber"
 objItem.Home2TelephoneNumber = valueOfItem
Case "HomeAddress"
 objItem.HomeAddress = valueOfItem
'MM
Case "HomeAddressStreet"
 objItem.HomeAddressStreet = valueOfItem
Case "HomeAddressCity"
 objItem.HomeAddressCity = valueOfItem
Case "HomeAddressState"
 objItem.HomeAddressState = valueOfItem
Case "HomeAddressPostalCode"
 objItem.HomeAddressPostalCode = valueOfItem
Case "HomeAddressCountry"
 objItem.HomeAddressCountry = valueOfItem
Case "HomeAddressPostOfficeBox"
 objItem.HomeAddressPostOfficeBox = valueOfItem
 
Case "HomeFaxNumber"
 objItem.HomeFaxNumber = valueOfItem
Case "HomeTelephoneNumber"
 objItem.HomeTelephoneNumber = valueOfItem
Case "HTMLBody"
 objItem.HTMLBody = valueOfItem
Case "IMAddress"
 objItem.IMAddress = valueOfItem
Case "Importance"
 If valueOfItem <> Empty Or valueOfItem <> "" Then
    If Val(valueOfItem) > 2 Then
        objItem.Importance = 2
    Else
        objItem.Importance = valueOfItem
    End If
            
 End If
Case "Initials"
 objItem.Initials = valueOfItem
Case "InternetFreeBusyAddress"
 objItem.InternetFreeBusyAddress = valueOfItem
Case "ISDNNumber"
 objItem.ISDNNumber = valueOfItem
Case "IsOnlineMeeting"
 objItem.IsOnlineMeeting = valueOfItem
Case "ItemProperties"
 objItem.itemProperties = valueOfItem
Case "JobTitle"
 objItem.JobTitle = valueOfItem
Case "Location"
 objItem.Location = valueOfItem
Case "Language"
 objItem.Language = valueOfItem
Case "MailingAddress"
 objItem.MailingAddress = valueOfItem
Case "ManagerName"
 objItem.ManagerName = valueOfItem
Case "MarkForDownload"
 objItem.MarkForDownload = valueOfItem
Case "MeetingStatus"
 objItem.MeetingStatus = valueOfItem
Case "Mileage"
 objItem.Mileage = valueOfItem
Case "MiddleName"
 objItem.MiddleName = valueOfItem
Case "MobileTelephoneNumber"
 objItem.MobileTelephoneNumber = valueOfItem
Case "NetMeetingAlias"
 objItem.NetMeetingAlias = valueOfItem
Case "NetMeetingAutoStart"
 objItem.NetMeetingAutoStart = valueOfItem
Case "NetMeetingDocPathName"
 objItem.NetMeetingDocPathName = valueOfItem
Case "NetMeetingOrganizerAlias"
 objItem.NetMeetingOrganizerAlias = valueOfItem
Case "NetMeetingServer"
 objItem.NetMeetingServer = valueOfItem
Case "NetMeetingType"
 objItem.NetMeetingType = valueOfItem
Case "NetShowURL"
 objItem.NetShowURL = valueOfItem
Case "NickName"
 objItem.NickName = valueOfItem
Case "NoAging"
 objItem.NoAging = valueOfItem
Case "OfficeLocation"
 objItem.OfficeLocation = valueOfItem
Case "OptionalAttendees"
 objItem.OptionalAttendees = valueOfItem
Case "OrganizationalIDNumber"
 objItem.OrganizationalIDNumber = valueOfItem
Case "OriginatorDeliveryReportRequested"
 objItem.OriginatorDeliveryReportRequested = valueOfItem
Case "OtherAddress"
 objItem.OtherAddress = valueOfItem
'MM
Case "OtherAddressStreet"
 objItem.OtherAddressStreet = valueOfItem
Case "OtherAddressCity"
 objItem.OtherAddressCity = valueOfItem
Case "OtherAddressState"
 objItem.OtherAddressState = valueOfItem
Case "OtherAddressPostalCode"
 objItem.OtherAddressPostalCode = valueOfItem
Case "OtherAddressCountry"
 objItem.OtherAddressCountry = valueOfItem
Case "OtherAddressPostOfficeBox"
 objItem.OtherAddressPostOfficeBox = valueOfItem
 
Case "OtherFaxNumber"
 objItem.OtherFaxNumber = valueOfItem
Case "OtherTelephoneNumber"
 objItem.OtherTelephoneNumber = valueOfItem
Case "Owner"
 objItem.Owner = valueOfItem
Case "PagerNumber"
 objItem.PagerNumber = valueOfItem
Case "PercentComplete"
  If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    objItem.PercentComplete = CLng(valueOfItem)
  End If

'Modified: correspondance <HomeWebPage> (SIF) -> "Personal Home Page" (Outlook)
Case "HomeWebPage"
 objItem.PersonalHomePage = valueOfItem

Case "PrimaryTelephoneNumber"
 objItem.PrimaryTelephoneNumber = valueOfItem
Case "Profession"
 objItem.Profession = valueOfItem
Case "RadioTelephoneNumber"
 objItem.RadioTelephoneNumber = valueOfItem
Case "ReadReceiptRequested"
 objItem.ReadReceiptRequested = valueOfItem
Case "ReplyTime"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    'objItem.End = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.End = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.ReplyTime = tmpDate
    Else
        objItem.ReplyTime = referredMaxDate
    End If
  End If
Case "Role"
 objItem.Role = valueOfItem
Case "SchedulePlusPriority"
 objItem.SchedulePlusPriority = valueOfItem
Case "SelectedMailingAddress"
 objItem.SelectedMailingAddress = valueOfItem
Case "SentOnBehalfOfName"
 objItem.SentOnBehalfOfName = valueOfItem
Case "Sensitivity"
'they could be "PUBLIC" / "PRIVATE" / "CONFIDENTIAL. currently not handled
 If valueOfItem <> Empty Or valueOfItem <> "" Then
    objItem.Sensitivity = valueOfItem
 End If
 Case "ReminderTime"
  If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    'objItem.End = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.End = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.ReminderTime = tmpDate
    Else
        objItem.ReminderTime = referredMaxDate
    End If
  End If
Case "Spouse"
 objItem.Spouse = valueOfItem
Case "Start"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    'objItem.Start = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.Start = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.Start = tmpDate
    Else
        objItem.Start = referredMaxDate
    End If
 End If
Case "StartDate"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    tmpDate = Empty
    tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
    'objItem.StartDate = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.StartDate = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.StartDate = tmpDate
    Else
        objItem.StartDate = referredMaxDate
    End If
 End If
Case "Status"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    objItem.Status = valueOfItem
 End If
Case "Subject"
 objItem.Subject = valueOfItem
Case "Suffix"
 objItem.Suffix = valueOfItem
Case "TeamTask"
  If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
   objItem.TeamTask = valueOfItem
  End If
Case "TelexNumber"
 objItem.TelexNumber = valueOfItem
Case "Title"
 objItem.Title = valueOfItem
Case "To"
 objItem.To = valueOfItem
Case "TotalWork"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
    objItem.TotalWork = valueOfItem
 End If
Case "TTYTDDTelephoneNumber"
 objItem.TTYTDDTelephoneNumber = valueOfItem
Case "UnRead"
 objItem.UnRead = valueOfItem
Case "User1"
 objItem.User1 = valueOfItem
Case "User2"
 objItem.User2 = valueOfItem
Case "User3"
 objItem.User3 = valueOfItem
Case "User4"
 objItem.User4 = valueOfItem
Case "UserCertificate"
 objItem.UserCertificate = valueOfItem
Case "UserProperties"
 objItem.UserProperties = valueOfItem
Case "VotingOptions"
 objItem.VotingOptions = valueOfItem
Case "VotingResponse"
 objItem.VotingResponse = valueOfItem
Case "WebPage"
 objItem.WebPage = valueOfItem
Case "YomiCompanyName"
 objItem.YomiCompanyName = valueOfItem
Case "YomiFirstName"
 objItem.YomiFirstName = valueOfItem
Case "YomiLastName"
 objItem.YomiLastName = valueOfItem
Case "FirstName"
 objItem.FirstName = valueOfItem
Case "LastName"
 objItem.LastName = valueOfItem
Case "ReminderSet"
 objItem.ReminderSet = valueOfItem
Case "ReminderMinutesBeforeStart"
 objItem.ReminderMinutesBeforeStart = valueOfItem
'MM for Recurrence
'Case "IsRecurring"
'  objItem.IsRecurring = valueOfItem
Case "RecurrenceType"
  objItem.recurrenceType = valueOfItem
Case "Interval"
  objItem.interval = valueOfItem
Case "MonthOfYear"
  objItem.monthOfYear = valueOfItem
Case "DayOfMonth"
  objItem.dayOfMonth = valueOfItem
Case "DayOfWeekMask"
  objItem.dayOfWeekMask = valueOfItem
Case "Instance"
  objItem.instance = valueOfItem
Case "PatternStartDate"
 If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
  tmpDate = Empty
  tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
  'objItem.PatternStartDate = Format(CDate(valueOfItem), "yyyyMMddTHHmmss") 'valueOfItem
    If tmpDate < limitMaxDate Then
        'objItem.PatternStartDate = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.patternStartDate = tmpDate
    Else
        objItem.patternStartDate = referredMaxDate
    End If
 End If
Case "PatternEndDate"
If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
  tmpDate = Empty
  tmpDate = Format(CDate(valueOfItem), "yyyy/mm/dd hh:mm:ss") 'valueOfItem
  'objItem.PatternEndDate = Format(CDate(valueOfItem), "dd/mm/yyyy hh:mm:ss") 'valueOfItem

  If tmpDate < limitMaxDate Then
        'objItem.PatternEndDate = mdMMTimeUtils.UTCToLocal(tmpDate)
        objItem.PatternEndDate = tmpDate
    Else
        objItem.PatternEndDate = referredMaxDate
    End If

End If
Case "NoEndDate"
If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
  objItem.noEndDate = valueOfItem
End If
Case "Occurrences"
If valueOfItem <> Empty Or valueOfItem <> Null Or valueOfItem <> "" Then
  objItem.occurrences = valueOfItem
End If

Case "Color"
  objItem.Color = valueOfItem
Case "Height"
  objItem.Height = valueOfItem
Case "Width"
  objItem.Width = valueOfItem
Case "Top"
  objItem.Top = valueOfItem
Case "Left"
  objItem.Left = valueOfItem
  
End Select


'save the chages in Item property
'MM
'objItem.Save

letItemPropertyValue_Exit:
    Exit Sub

letItemPropertyValue_Err:

    Dim actionToDo As Integer
    
    If Err.number = 380 Then 'Invalid property value
        logToDebug "You receive a not valid value for the Item Property. The Item with the EntryID" _
        & Chr(13) & objItem.EntryID & Chr(13) & "was not properly setted."
        Resume Next
    End If
    If Err.number = 438 Then 'Object doesn't support this property or method
        logToDebug "You receive a not valid Item Property for the current Item type. The Item with the EntryID" _
        & Chr(13) & objItem.EntryID & Chr(13) & "will not be completely setted."
        Exit Sub
    End If

    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo letItemPropertyValue_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub



